"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.sortObjectArrByProps = void 0;
function sortObjectArrByProps(objArr, objProps, reverse = 's') {
    let sortedObjectArray = [];
    let values = [];
    let indices = [];
    let highestValue = [];
    const greaterString = (text) => {
        if (text.length === 0) {
            return "0";
        }
        else {
            const greaterFirstCharCode = text.charCodeAt(0) + 1;
            return `${String.fromCharCode(greaterFirstCharCode)}`;
        }
    };
    const increment = (item) => {
        if (typeof item === 'number') {
            return item + 1;
        }
        else if (typeof item === 'string') {
            return greaterString(item);
        }
    };
    if (!!Array.isArray(objProps)) {
        for (let i = 0; i < objProps.length; i++) {
            highestValue[i] = {
                value: objArr[0][objProps[i]],
                type: typeof objArr[0][objProps[i]]
            };
            for (let j = 1; j < objArr.length; j++) {
                if (objArr[j][objProps[i]] !== undefined) {
                    if (highestValue[i].value === undefined
                        || objArr[j][objProps[i]] > highestValue[i].value) {
                        highestValue[i].value = objArr[j][objProps[i]];
                        if (highestValue[i].type === 'undefined') {
                            highestValue[i].type = typeof objArr[i][objProps[i]];
                        }
                    }
                }
            }
        }
    }
    else {
        highestValue[0] = {
            value: objArr[0][objProps],
            type: typeof objArr[0][objProps]
        };
        for (let i = 1; i < objArr.length; i++) {
            if (objArr[i][objProps] !== undefined) {
                if (highestValue[0].value === undefined
                    || objArr[i][objProps] > highestValue[0].value) {
                    highestValue[0].value = objArr[i][objProps];
                    if (highestValue[0].type === 'undefined') {
                        highestValue[0].type = typeof objArr[i][objProps];
                    }
                }
            }
        }
    }
    if (!!Array.isArray(objProps)) {
        for (let i = 0; i < objArr.length; i++) {
            values.push([]);
            indices.push(i);
        }
        for (let j = 0; j < objArr.length; j++) {
            for (let k = 0; k < objProps.length; k++) {
                if (objArr[j].hasOwnProperty(objProps[k])) {
                    values[j].push(objArr[j][objProps[k]]);
                }
                else {
                    values[j].push(increment(highestValue[k].value));
                }
            }
        }
    }
    else {
        objArr.forEach((obj, i) => {
            if (obj.hasOwnProperty(objProps)) {
                typeof objProps === 'string'
                    || typeof objProps === 'number'
                    ? values.push(obj[objProps])
                    : values.push(obj[objProps].toString());
            }
            else {
                values.push(increment(highestValue[0].value));
            }
            indices.push(i);
        });
    }
    if (!!Array.isArray(objProps)) {
        let k = 0;
        for (let i = 1; i < values.length; i++) {
            for (let j = 0; j < values.length - i;) {
                if (values[j][k] === values[j + 1][k]) {
                    if (k === objProps.length - 1) {
                        k = 0;
                        j++;
                    }
                    else {
                        k++;
                    }
                }
                else if (values[j][k] > values[j + 1][k]) {
                    [values[j], values[j + 1]] = [values[j + 1], values[j]];
                    [indices[j], indices[j + 1]] = [indices[j + 1], indices[j]];
                    k = 0;
                    j++;
                }
                else {
                    k = 0;
                    j++;
                }
            }
        }
    }
    else {
        for (let i = 1; i < values.length; i++) {
            for (let j = 0; j < values.length - i; j++) {
                if (values[j] > values[j + 1]) {
                    [values[j], values[j + 1]] = [values[j + 1], values[j]];
                    [indices[j], indices[j + 1]] = [indices[j + 1], indices[j]];
                }
            }
        }
    }
    for (let i of indices) {
        sortedObjectArray.push(objArr[i]);
    }
    reverse === 'r'.toLowerCase() && sortedObjectArray.reverse();
    return sortedObjectArray;
}
exports.sortObjectArrByProps = sortObjectArrByProps;
